ScriptSelector (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.optional, class: ScriptSelector

# Class ScriptSelector

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.selectors.BaseSelector
org.apache.tools.ant.types.optional.ScriptSelector

All Implemented Interfaces:
  `Cloneable, ResourceSelector, FileSelector`

public class ScriptSelector extends BaseSelector
Selector that lets you run a script with selection logic inline

Since:
  Ant1.7

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ScriptSelector()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addText(String text)`
  The script text.
  `Path`
  `createClasspath()`
  Classpath to be used when searching for classes and resources.
  `File`
  `getBasedir()`
  get the base directory
  `File`
  `getFile()`
  get the file that is currently to be tested
  `String`
  `getFilename()`
  get the filename of the file
  `boolean`
  `isSelected()`
  get state of selected flag
  `boolean`
  `isSelected(File basedir, String filename, File file)`
  Method that each selector will implement to create their selection behaviour.
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to be used when searching for classes and resources.
  `void`
  `setClasspathRef(Reference r)`
  Set the classpath by reference.
  `void`
  `setEncoding(String encoding)`
  Set the encoding of the script from an external file; optional.
  `void`
  `setLanguage(String language)`
  Defines the language (required).
  `void`
  `setManager(String manager)`
  Deprecated.
  `void`
  `setManager(ScriptManager manager)`
  Set the script manager.
  `void`
  `setProject(Project project)`
  Set the project.
  `void`
  `setSelected(boolean selected)`
  set the selected state Intended for script use, not as an Ant attribute
  `void`
  `setSetBeans(boolean setBeans)`
  Set the setbeans attribute.
  `void`
  `setSrc(File file)`
  Load the script from an external file; optional.

  ### Methods inherited from class BaseSelector

  `getError, setError, setError, validate, verifySettings`
  Modifier and Type
  Method
  Description
  `String`
  `getError()`
  Returns any error messages that have been set.
  `void`
  `setError(String msg)`
  Allows all selectors to indicate a setup error.
  `void`
  `setError(String msg, Throwable cause)`
  Allows all selectors to indicate a setup error.
  `void`
  `validate()`
  Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.
  `void`
  `verifySettings()`
  Subclasses can override this method to provide checking of their state.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface FileSelector

  `isSelected`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isSelected(Resource r)`
  Implement a basic `Resource` selection that delegates to this `FileSelector`.

- ## Constructor Details

  - ### ScriptSelector

    public ScriptSelector()

- ## Method Details

  - ### setProject

    public void setProject(Project project)
    Set the project.
    Overrides:
      `setProject` in class `ProjectComponent`
    Parameters:
      `project` - the owner of this component.

  - ### setManager

    @Deprecated public void setManager(String manager)
    Deprecated.
    Defines the manager.
    Parameters:
      `manager` - the scripting manager.

  - ### setManager

    public void setManager(ScriptManager manager)
    Set the script manager.
    Parameters:
      `manager` -

  - ### setLanguage

    public void setLanguage(String language)
    Defines the language (required).
    Parameters:
      `language` - the scripting language name for the script.

  - ### setSrc

    public void setSrc(File file)
    Load the script from an external file; optional.
    Parameters:
      `file` - the file containing the script source.

  - ### addText

    public void addText(String text)
    The script text.
    Parameters:
      `text` - a component of the script text to be added.

  - ### setClasspath

    public void setClasspath(Path classpath)
    Set the classpath to be used when searching for classes and resources.
    Parameters:
      `classpath` - an Ant Path object containing the search path.

  - ### createClasspath

    public Path createClasspath()
    Classpath to be used when searching for classes and resources.
    Returns:
      an empty Path instance to be configured by Ant.

  - ### setClasspathRef

    public void setClasspathRef(Reference r)
    Set the classpath by reference.
    Parameters:
      `r` - a Reference to a Path instance to be used as the classpath value.

  - ### setSetBeans

    public void setSetBeans(boolean setBeans)
    Set the setbeans attribute. If this is true, <script> will create variables in the script instance for all properties, targets and references of the current project. It this is false, only the project and self variables will be set. The default is true.
    Parameters:
      `setBeans` - the value to set.

  - ### isSelected

    public boolean isSelected(File basedir, String filename, File file)
    Method that each selector will implement to create their selection behaviour. If there is a problem with the setup of a selector, it can throw a BuildException to indicate the problem.
    Specified by:
      `isSelected` in interface `FileSelector`
    Specified by:
      `isSelected` in class `BaseSelector`
    Parameters:
      `basedir` - A java.io.File object for the base directory
      `filename` - The name of the file to check
      `file` - A File object for this filename
    Returns:
      whether the file should be selected or not

  - ### getBasedir

    public File getBasedir()
    get the base directory
    Returns:
      the base directory

  - ### getFilename

    public String getFilename()
    get the filename of the file
    Returns:
      the filename of the file that is currently been tested

  - ### getFile

    public File getFile()
    get the file that is currently to be tested
    Returns:
      the file that is currently been tested

  - ### isSelected

    public boolean isSelected()
    get state of selected flag
    Returns:
      the selected flag

  - ### setSelected

    public void setSelected(boolean selected)
    set the selected state Intended for script use, not as an Ant attribute
    Parameters:
      `selected` - the selected state

  - ### setEncoding

    public void setEncoding(String encoding)
    Set the encoding of the script from an external file; optional.
    Parameters:
      `encoding` - the encoding of the file containing the script source.
    Since:
      Ant 1.10.2